Package org.fife.ui.rsyntaxtextarea

## Class TokenMakerFactory

- java.lang.Object
- - org.fife.ui.rsyntaxtextarea.TokenMakerFactory

- Direct Known Subclasses:
    `AbstractTokenMakerFactory`

      public abstract class TokenMakerFactory
      extends Object

  A factory that maps syntax styles to `TokenMaker`s capable of splitting text into tokens for those syntax styles.

- - ### Field Summary

    Fields
    Modifier and Type | Field | Description
    --- | --- | ---
    `static String` | `PROPERTY_DEFAULT_TOKEN_MAKER_FACTORY` | If this system property is set, a custom `TokenMakerFactory` of the specified class will be used as the default token maker factory.

  - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `TokenMakerFactory()` |

  - ### Method Summary

    All Methods Static Methods Instance Methods Abstract Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static TokenMakerFactory` | `getDefaultInstance()` | Returns the default `TokenMakerFactory` instance.
    `TokenMaker` | `getTokenMaker​(String key)` | Returns a `TokenMaker` for the specified key.
    `protected abstract TokenMaker` | `getTokenMakerImpl​(String key)` | Returns a `TokenMaker` for the specified key.
    `abstract Set<String>` | `keySet()` | Returns the set of keys that this factory maps to token makers.
    `static void` | `setDefaultInstance​(TokenMakerFactory tmf)` | Sets the default `TokenMakerFactory` instance.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### PROPERTY_DEFAULT_TOKEN_MAKER_FACTORY

          public static final String PROPERTY_DEFAULT_TOKEN_MAKER_FACTORY

      If this system property is set, a custom `TokenMakerFactory` of the specified class will be used as the default token maker factory.
      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### TokenMakerFactory

          public TokenMakerFactory()

  - ### Method Detail

    - #### getDefaultInstance

          public static TokenMakerFactory getDefaultInstance()

      Returns the default `TokenMakerFactory` instance. This is the factory used by all `RSyntaxDocument`s by default.
      Returns:
        The factory.
      See Also:
        `setDefaultInstance(TokenMakerFactory)`

    - #### getTokenMaker

          public final TokenMaker getTokenMaker​(String key)

      Returns a `TokenMaker` for the specified key.
      Parameters:
        `key` - The key.
      Returns:
        The corresponding `TokenMaker`, or `PlainTextTokenMaker` if none matches the specified key.

    - #### getTokenMakerImpl

          protected abstract TokenMaker getTokenMakerImpl​(String key)

      Returns a `TokenMaker` for the specified key.
      Parameters:
        `key` - The key.
      Returns:
        The corresponding `TokenMaker`, or `null` if none matches the specified key.

    - #### keySet

          public abstract Set<String> keySet()

      Returns the set of keys that this factory maps to token makers.
      Returns:
        The set of keys.

    - #### setDefaultInstance

          public static void setDefaultInstance​(TokenMakerFactory tmf)

      Sets the default `TokenMakerFactory` instance. This is the factory used by all future `RSyntaxDocument`s by default. `RSyntaxDocument`s that have already been created are not affected.
      Parameters:
        `tmf` - The factory.
      Throws:
        `IllegalArgumentException` - If `tmf` is `null`.
      See Also:
        `getDefaultInstance()`